//     .
unit Arrays;
uses Types, Containers;

// ,      [min, max].
function CreateRandomIntArray(count, min, max: int): IntArray;
var
  i: int;

begin
  Result := IntArray.Create();
  for i := 1 to count do
    Result.Add(Min + Random(Max - Min + 1));
end;

// ,      [0, 100].
function CreateRandomIntArray(count: int): IntArray;
begin
  Result := CreateRandomIntArray(count, 0, 100);
end;

// ,  ,  -      .
function ArrGen(count: int; selector: IntSelector1): IntArray;
var
  i: int;

begin
  Result := IntArray.Create();
  for i := 1 to count do
    Result.Add(selector(i));
end;
end.