//     .
unit Reader;
interface
  uses Types, Tuples, Containers;

  //  x1, x2   y.
  procedure SetValues(x1, x2, y1, y2: object);

  //  x1, x2, x3   y.
  procedure SetValues(x1, x2, x3, y1, y2, y3: object);

  //  x1, x2, x3, x4   y.
  procedure SetValues(x1, x2, x3, x4, y1, y2, y3, y4: object);

  //  x1, x2, x3, x4, x5   y.
  procedure SetValues(x1, x2, x3, x4, x5, y1, y2, y3, y4, y5: object);

  //  x1, x2, x3, x4, x5, x6   y.
  procedure SetValues(x1, x2, x3, x4, x5, x6, y1, y2, y3, y4, y5, y6: object);

  //  x1, x2, x3, x4, x5, x6, x7   y.
  procedure SetValues(x1, x2, x3, x4, x5, x6, x7, y1, y2, y3, y4, y5, y6, y7: object);


  //       .
  function ReadlnInt(prompt: string): int;

  //       .
  function ReadlnReal(prompt: string): real;

  //      .
  function ReadlnChar(prompt: string): char;

  //      .
  function ReadlnString(prompt: string): string;

  //       .
  function ReadlnInt: int;

  //       .
  function ReadlnReal: real;

  //      .
  function ReadlnChar: char;

  //      .
  function ReadlnString: string;


  //         .
  function ReadlnComplex(prompt: string): PComplex;
  
  //         .
  function ReadlnComplex: PComplex;


  //        .
  function ReadlnIntTuple2(prompt: string): IntTuple2; // <<<

  //        .
  function ReadlnIntTuple3(prompt: string): IntTuple3;

  //        .
  function ReadlnIntTuple4(prompt: string): IntTuple4;

  //        .
  function ReadlnIntTuple5(prompt: string): IntTuple5;

  //        .
  function ReadlnIntTuple6(prompt: string): IntTuple6;

  //        .
  function ReadlnIntTuple7(prompt: string): IntTuple7;


  //        .
  function ReadlnRealTuple2(prompt: string): RealTuple2; // <<<

  //        .
  function ReadlnRealTuple3(prompt: string): RealTuple3;

  //        .
  function ReadlnRealTuple4(prompt: string): RealTuple4;

  //        .
  function ReadlnRealTuple5(prompt: string): RealTuple5;

  //        .
  function ReadlnRealTuple6(prompt: string): RealTuple6;

  //       .
  function ReadlnRealTuple7(prompt: string): RealTuple7;


  //       .
  function ReadlnCharTuple2(prompt: string): CharTuple2; // <<<

  //       .
  function ReadlnCharTuple3(prompt: string): CharTuple3;

  //       .
  function ReadlnCharTuple4(prompt: string): CharTuple4;

  //       .
  function ReadlnCharTuple5(prompt: string): CharTuple5;

  //       .
  function ReadlnCharTuple6(prompt: string): CharTuple6;


  //       .
  function ReadlnCharTuple7(prompt: string): CharTuple7;

  //       .
  function ReadlnStringTuple2(prompt: string): StringTuple2; // <<<

  //       .
  function ReadlnStringTuple3(prompt: string): StringTuple3;

  //       .
  function ReadlnStringTuple4(prompt: string): StringTuple4;

  //       .
  function ReadlnStringTuple5(prompt: string): StringTuple5;

  //       .
  function ReadlnStringTuple6(prompt: string): StringTuple6;

  //       .
  function ReadlnStringTuple7(prompt: string): StringTuple7;


  //        .
  function ReadlnIntTuple2: IntTuple2; // <<<

  //        .
  function ReadlnIntTuple3: IntTuple3;

  //        .
  function ReadlnIntTuple4: IntTuple4;

  //        .
  function ReadlnIntTuple5: IntTuple5;

  //        .
  function ReadlnIntTuple6: IntTuple6;

  //        .
  function ReadlnIntTuple7: IntTuple7;

  //        .
  function ReadlnRealTuple2: RealTuple2; // <<<

  //        .
  function ReadlnRealTuple3: RealTuple3;

  //        .
  function ReadlnRealTuple4: RealTuple4;

  //        .
  function ReadlnRealTuple5: RealTuple5;

  //        .
  function ReadlnRealTuple6: RealTuple6;

  //        .
  function ReadlnRealTuple7: RealTuple7;


  //       .
  function ReadlnCharTuple2: CharTuple2; // <<<

  //       .
  function ReadlnCharTuple3: CharTuple3;

  //       .
  function ReadlnCharTuple4: CharTuple4;

  //       .
  function ReadlnCharTuple5: CharTuple5;

  //       .
  function ReadlnCharTuple6: CharTuple6;

  //       .
  function ReadlnCharTuple7: CharTuple7;


  //       .
  function ReadlnStringTuple2: StringTuple2; // <<<

  //       .
  function ReadlnStringTuple3: StringTuple3;

  //       .
  function ReadlnStringTuple4: StringTuple4;

  //       .
  function ReadlnStringTuple5: StringTuple5;

  //       .
  function ReadlnStringTuple6: StringTuple6;

  //       .
  function ReadlnStringTuple7: StringTuple7;


  //        .
  function ReadArrInt(count: int; prompt: string): IntArray;

  //        .
  function ReadArrReal(count: int; prompt: string): RealArray;

  //       .
  function ReadArrString(count: int; prompt: string): StringArray;

  //        .
  function ReadArrInt(count: int): IntArray;

  //        .
  function ReadArrReal(count: int): RealArray;

  //       .
  function ReadArrString(count: int): StringArray;
  
  
  ///              .
  function ReadIntSeqWhile(prompt: string; p: IntPredicate1): IntArray;

  ///              .
  function ReadRealSeqWhile(prompt: string; p: RealPredicate1): RealArray;

  ///             .
  function ReadStringSeqWhile(prompt: string; p: StringPredicate1): StringArray;

  ///              .
  function ReadIntSeqWhile(p: IntPredicate1): IntArray;

  ///              .
  function ReadRealSeqWhile(p: RealPredicate1): RealArray;

  ///             .
  function ReadStringSeqWhile(p: StringPredicate1): StringArray;
  
implementation
  const
    Delimiter = ': ';
    Item1 = 'Item1' + Delimiter;
    Item2 = 'Item2' + Delimiter;
    Item3 = 'Item3' + Delimiter;
    Item4 = 'Item4' + Delimiter;
    Item5 = 'Item5' + Delimiter;
    Item6 = 'Item6' + Delimiter;
    Item7 = 'Item7' + Delimiter;

  procedure SetValues(x1, x2, y1, y2: object);
  begin
    x1 := y1;
    x2 := y2;
  end;

  procedure SetValues(x1, x2, x3, y1, y2, y3: object);
  begin
    SetValues(x1, x2, y1, y2);
    x3 := y3;
  end;

  procedure SetValues(x1, x2, x3, x4, y1, y2, y3, y4: object);
  begin
    SetValues(x1, x2, x3, y1, y2, y3);
    x4 := y4;
  end;

  procedure SetValues(x1, x2, x3, x4, x5, y1, y2, y3, y4, y5: object);
  begin
    SetValues(x1, x2, x3, x4, y1, y2, y3, y4);
    x5 := y5;
  end;

  procedure SetValues(x1, x2, x3, x4, x5, x6, y1, y2, y3, y4, y5, y6: object);
  begin
    SetValues(x1, x2, x3, x4, x5, y1, y2, y3, y4, y5);
    x6 := y6;
  end;

  procedure SetValues(x1, x2, x3, x4, x5, x6, x7, y1, y2, y3, y4, y5, y6, y7: object);
  begin
    SetValues(x1, x2, x3, x4, x5, x6, y1, y2, y3, y4, y5, y6);
    x7 := y7;
  end;

  function ReadlnInt(prompt: string): int;
  begin
    Write(prompt);
    Readln(Result);
  end;

  function ReadlnReal(prompt: string): real;
  begin
    Write(prompt);
    Readln(Result);
  end;

  function ReadlnChar(prompt: string): char;
  begin
    Write(prompt);
    Readln(Result);
  end;

  function ReadlnString(prompt: string): string;
  begin
    Write(prompt);
    Readln(Result);
  end;

  function ReadlnInt: int;
  begin
    Result := ReadlnInt('');
  end;

  function ReadlnReal: real;
  begin
    Result := ReadlnReal('');
  end;

  function ReadlnChar: char;
  begin
    Result := ReadlnChar('');
  end;

  function ReadlnString: string;
  begin
    Result := ReadlnString('');
  end;


  function ReadlnComplex(prompt: string): PComplex;
  begin
    Writeln(prompt);
    New(Result);
    Result^.Re := ReadlnReal('Re' + Delimiter);
    Result^.Im := ReadlnReal('Im' + Delimiter);
  end;

  function ReadlnComplex: PComplex;
  begin
    Result := ReadlnComplex('');
  end;


  function ReadlnIntTuple2(prompt: string): IntTuple2; // <<<
  begin
    Writeln(prompt);
    Result := IntTpl2(ReadlnInt(Item1), ReadlnInt(Item2));
  end;

  function ReadlnIntTuple3(prompt: string): IntTuple3;
  begin
    Writeln(prompt);
    Result := IntTpl3(ReadlnInt(Item1), ReadlnInt(Item2), ReadlnInt(Item3));
  end;

  function ReadlnIntTuple4(prompt: string): IntTuple4;
  begin
    Writeln(prompt);
    Result := IntTpl4(ReadlnInt(Item1), ReadlnInt(Item2), ReadlnInt(Item3), ReadlnInt(Item4));
  end;

  function ReadlnIntTuple5(prompt: string): IntTuple5;
  begin
    Writeln(prompt);
    Result := IntTpl5(ReadlnInt(Item1), ReadlnInt(Item2), ReadlnInt(Item3), ReadlnInt(Item4), ReadlnInt(Item5));
  end;

  function ReadlnIntTuple6(prompt: string): IntTuple6;
  begin
    Writeln(prompt);
    Result := IntTpl6(ReadlnInt(Item1), ReadlnInt(Item2), ReadlnInt(Item3), ReadlnInt(Item4), ReadlnInt(Item5), ReadlnInt(Item6));
  end;

  function ReadlnIntTuple7(prompt: string): IntTuple7;
  begin
    Writeln(prompt);
    Result := IntTpl7(ReadlnInt(Item1), ReadlnInt(Item2), ReadlnInt(Item3), ReadlnInt(Item4), ReadlnInt(Item5), ReadlnInt(Item6), ReadlnInt(Item7));
  end;
  
  
  function ReadlnRealTuple2(prompt: string): RealTuple2; // <<<
  begin
    Writeln(prompt);
    Result := RealTpl2(ReadlnReal(Item1), ReadlnReal(Item2));
  end;

  function ReadlnRealTuple3(prompt: string): RealTuple3;
  begin
    Writeln(prompt);
    Result := RealTpl3(ReadlnReal(Item1), ReadlnReal(Item2), ReadlnReal(Item3));
  end;

  function ReadlnRealTuple4(prompt: string): RealTuple4;
  begin
    Writeln(prompt);
    Result := RealTpl4(ReadlnReal(Item1), ReadlnReal(Item2), ReadlnReal(Item3), ReadlnReal(Item4));
  end;

  function ReadlnRealTuple5(prompt: string): RealTuple5;
  begin
    Writeln(prompt);
    Result := RealTpl5(ReadlnReal(Item1), ReadlnReal(Item2), ReadlnReal(Item3), ReadlnReal(Item4), ReadlnReal(Item5));
  end;

  function ReadlnRealTuple6(prompt: string): RealTuple6;
  begin
    Writeln(prompt);
    Result := RealTpl6(ReadlnReal(Item1), ReadlnReal(Item2), ReadlnReal(Item3), ReadlnReal(Item4), ReadlnReal(Item5), ReadlnReal(Item6));
  end;

  function ReadlnRealTuple7(prompt: string): RealTuple7;
  begin
    Writeln(prompt);
    Result := RealTpl7(ReadlnReal(Item1), ReadlnReal(Item2), ReadlnReal(Item3), ReadlnReal(Item4), ReadlnReal(Item5), ReadlnReal(Item6), ReadlnReal(Item7));
  end;
  
  
  function ReadlnCharTuple2(prompt: string): CharTuple2; // <<<
  begin
    Writeln(prompt);
    Result := CharTpl2(ReadlnChar(Item1), ReadlnChar(Item2));
  end;

  function ReadlnCharTuple3(prompt: string): CharTuple3;
  begin
    Writeln(prompt);
    Result := CharTpl3(ReadlnChar(Item1), ReadlnChar(Item2), ReadlnChar(Item3));
  end;

  function ReadlnCharTuple4(prompt: string): CharTuple4;
  begin
    Writeln(prompt);
    Result := CharTpl4(ReadlnChar(Item1), ReadlnChar(Item2), ReadlnChar(Item3), ReadlnChar(Item4));
  end;

  function ReadlnCharTuple5(prompt: string): CharTuple5;
  begin
    Writeln(prompt);
    Result := CharTpl5(ReadlnChar(Item1), ReadlnChar(Item2), ReadlnChar(Item3), ReadlnChar(Item4), ReadlnChar(Item5));
  end;

  function ReadlnCharTuple6(prompt: string): CharTuple6;
  begin
    Writeln(prompt);
    Result := CharTpl6(ReadlnChar(Item1), ReadlnChar(Item2), ReadlnChar(Item3), ReadlnChar(Item4), ReadlnChar(Item5), ReadlnChar(Item6));
  end;

  function ReadlnCharTuple7(prompt: string): CharTuple7;
  begin
    Writeln(prompt);
    Result := CharTpl7(ReadlnChar(Item1), ReadlnChar(Item2), ReadlnChar(Item3), ReadlnChar(Item4), ReadlnChar(Item5), ReadlnChar(Item6), ReadlnChar(Item7));
  end;
  
  
  function ReadlnStringTuple2(prompt: string): StringTuple2; // <<<
  begin
    Writeln(prompt);
    Result := StringTpl2(ReadlnString(Item1), ReadlnString(Item2));
  end;

  function ReadlnStringTuple3(prompt: string): StringTuple3;
  begin
    Writeln(prompt);
    Result := StringTpl3(ReadlnString(Item1), ReadlnString(Item2), ReadlnString(Item3));
  end;

  function ReadlnStringTuple4(prompt: string): StringTuple4;
  begin
    Writeln(prompt);
    Result := StringTpl4(ReadlnString(Item1), ReadlnString(Item2), ReadlnString(Item3), ReadlnString(Item4));
  end;

  function ReadlnStringTuple5(prompt: string): StringTuple5;
  begin
    Writeln(prompt);
    Result := StringTpl5(ReadlnString(Item1), ReadlnString(Item2), ReadlnString(Item3), ReadlnString(Item4), ReadlnString(Item5));
  end;

  function ReadlnStringTuple6(prompt: string): StringTuple6;
  begin
    Writeln(prompt);
    Result := StringTpl6(ReadlnString(Item1), ReadlnString(Item2), ReadlnString(Item3), ReadlnString(Item4), ReadlnString(Item5), ReadlnString(Item6));
  end;

  function ReadlnStringTuple7(prompt: string): StringTuple7;
  begin
    Writeln(prompt);
    Result := StringTpl7(ReadlnString(Item1), ReadlnString(Item2), ReadlnString(Item3), ReadlnString(Item4), ReadlnString(Item5), ReadlnString(Item6), ReadlnString(Item7));
  end;
  
  
  function ReadlnIntTuple2: IntTuple2; // <<<
  begin
    Result := ReadlnIntTuple2('');
  end;
  
  function ReadlnIntTuple3: IntTuple3;
  begin
    Result := ReadlnIntTuple3('');
  end;
  
  function ReadlnIntTuple4: IntTuple4;
  begin
    Result := ReadlnIntTuple4('');
  end;
  
  function ReadlnIntTuple5: IntTuple5;
  begin
    Result := ReadlnIntTuple5('');
  end;
  
  function ReadlnIntTuple6: IntTuple6;
  begin
    Result := ReadlnIntTuple6('');
  end;
  
  function ReadlnIntTuple7: IntTuple7;
  begin
    Result := ReadlnIntTuple7('');
  end;
  
  function ReadlnRealTuple2: RealTuple2; // <<<
  begin
    Result := ReadlnRealTuple2('');
  end;

  function ReadlnRealTuple3: RealTuple3;
  begin
    Result := ReadlnRealTuple3('');
  end;

  function ReadlnRealTuple4: RealTuple4;
  begin
    Result := ReadlnRealTuple4('');
  end;

  function ReadlnRealTuple5: RealTuple5;
  begin
    Result := ReadlnRealTuple5('');
  end;

  function ReadlnRealTuple6: RealTuple6;
  begin
    Result := ReadlnRealTuple6('');
  end;

  function ReadlnRealTuple7: RealTuple7;
  begin
    Result := ReadlnRealTuple7('');
  end;
  
  function ReadlnCharTuple2: CharTuple2; // <<<
  begin
    Result := ReadlnCharTuple2('');
  end;

  function ReadlnCharTuple3: CharTuple3;
  begin
    Result := ReadlnCharTuple3('');
  end;

  function ReadlnCharTuple4: CharTuple4;
  begin
    Result := ReadlnCharTuple4('');
  end;

  function ReadlnCharTuple5: CharTuple5;
  begin
    Result := ReadlnCharTuple5('');
  end;

  function ReadlnCharTuple6: CharTuple6;
  begin
    Result := ReadlnCharTuple6('');
  end;

  function ReadlnCharTuple7: CharTuple7;
  begin
    Result := ReadlnCharTuple7('');
  end;
  
  function ReadlnStringTuple2: StringTuple2; // <<<
  begin
    Result := ReadlnStringTuple2('');
  end;

  function ReadlnStringTuple3: StringTuple3;
  begin
    Result := ReadlnStringTuple3('');
  end;

  function ReadlnStringTuple4: StringTuple4;
  begin
    Result := ReadlnStringTuple4('');
  end;

  function ReadlnStringTuple5: StringTuple5;
  begin
    Result := ReadlnStringTuple5('');
  end;

  function ReadlnStringTuple6: StringTuple6;
  begin
    Result := ReadlnStringTuple6('');
  end;

  function ReadlnStringTuple7: StringTuple7;
  begin
    Result := ReadlnStringTuple7('');
  end;
  
  function ReadArrInt(count: int; prompt: string): IntArray;
  var
    i: int;

  begin
    Writeln(prompt);
    Result := IntArray.Create();
    for i := 1 to count do
      Result.Add(ReadlnInt('Item' + IntToStr(i) + Delimiter));
  end;
  
  function ReadArrReal(count: int; prompt: string): RealArray;
  var
    i: int;

  begin
    Writeln(prompt);
    Result := RealArray.Create();
    for i := 1 to count do
      Result.Add(ReadlnReal('Item' + IntToStr(i) + Delimiter));
  end;
  
  function ReadArrString(count: int; prompt: string): StringArray;
  var
    i: int;

  begin
    Writeln(prompt);
    Result := StringArray.Create();
    for i := 1 to count do
      Result.Add(ReadlnString('Item' + IntToStr(i) + Delimiter));
  end;
  
  function ReadArrInt(count: int): IntArray;
  begin
    Result := ReadArrInt(count, '');
  end;
  
  function ReadArrReal(count: int): RealArray;
  begin
    Result := ReadArrReal(count, '');
  end;
  
  function ReadArrString(count: int): StringArray;
  begin
    Result := ReadArrString(count, '');
  end;
  
  function ReadIntSeqWhile(prompt: string; p: IntPredicate1): IntArray;
  var
    x: int;

  begin
    Writeln(prompt);
    Result := IntArray.Create();
    x := ReadlnInt();
    while p(x) do
    begin
      Result.Add(x);
      x := ReadlnInt();
    end;
  end;
  
  function ReadRealSeqWhile(prompt: string; p: RealPredicate1): RealArray;
  var
    x: real;

  begin
    Writeln(prompt);
    Result := RealArray.Create();
    x := ReadlnReal();
    while p(x) do
    begin
      Result.Add(x);
      x := ReadlnReal();
    end;
  end;
  
  function ReadStringSeqWhile(prompt: string; p: StringPredicate1): StringArray;
  var
    x: string;

  begin
    Writeln(prompt);
    Result := StringArray.Create();
    x := ReadlnString();
    while p(x) do
    begin
      Result.Add(x);
      x := ReadlnString();
    end;
  end;
  
  function ReadIntSeqWhile(p: IntPredicate1): IntArray;
  begin
    Result := ReadIntSeqWhile('', p);
  end;
  
  function ReadRealSeqWhile(p: RealPredicate1): RealArray;
  begin
    Result := ReadRealSeqWhile('', p);
  end;
  
  function ReadStringSeqWhile(p: StringPredicate1): StringArray;
  begin
    Result := ReadStringSeqWhile('', p);
  end;
end.